import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

public class Hanoi extends JApplet implements ActionListener {
  JTextField input;
  JTextArea output;
  public void init() {
    input = new JTextField("0", 8);
    input.addActionListener(this);
    output = new JTextArea(18, 22);
    getContentPane().setLayout(new FlowLayout());
    getContentPane().add(input);
    getContentPane().add(output);
  }

  void hanoi(int n, String a, String b, String c) {
    if (n==1) {
      output.append("~ 1A"+a+""+b+"ցB\n");
    }
    else {
      hanoi(n-1, a, c, b);
      output.append("~ "+n+"A"+a+""+b+"ցB\n");
      hanoi(n-1, c, b, a);
    }
  }
  
  public void actionPerformed(ActionEvent e) {
    int n = Integer.parseInt(input.getText());

    hanoi(n, "_A", "_B", "_C");
    output.append("ȏ\n\n");
  }

}
