public class PointTest {
  public static void main(String args[]) {
    //     Point p = new Point();
    //     p.x = 1; p.y = 2;
    //     p = addPoint(p, p);
    //     System.out.println("(" + p.x + ", " + p.y + ")");
    Point p = new Point(10, 20);
    p.move(1, -1);
    p.print();
    System.out.println("<br>");
    
    ColorPoint cp = new ColorPoint(20, 30, "green");
    cp.print();
    System.out.println("<br>");

    Point[] pts = new Point[2];
    pts[0] = p; pts[1] = cp;
    
    int i;
    for (i=0; i<2; i++) {
      pts[i].move(10, 10);
    }
    for (i=0; i<2; i++) {
      pts[i].print();
      System.out.println("<br>");
    }
    moveInSquare(p);
    moveInSquare(cp);
  }

  /*
    public static Point addPoint(Point pnt1, Point pnt2) {
    Point pnt3 = new Point();

    pnt3.x = pnt1.x + pnt2.x;
    pnt3.y = pnt1.y + pnt2.y;

    return pnt3;
    }
  */

  static void moveInSquare(Point p) {
    p.move(1, 0);
    p.print();
    System.out.print(" ");
    p.move(0, 1);
    p.print();
    System.out.print(" ");
    p.move(-1, 0);
    p.print();
    System.out.print(" ");
    p.move(0, -1);
    p.print();
    System.out.println("<br>");
  }
}


// version 1
// class Point {
//   public int x, y;
// }


// version 2
class Point {
  // tB[h(oϐj
  public int x;
  public int y;

  // \bhio֐j  
  public void move(int dx, int dy) {
    x += dx;
    y += dy;
  }

  public void print() {
    System.out.print("(" + x + ", " + y + ")");
  }

  // RXgN^
  public Point(int x0, int y0) {
    x = x0; y = y0;
  }
}


// version 1
// class ColorPoint extends Point {
//    public int color;  // 0- 1- 2- 3- 4- 5- 6- 7- 
//    public ColorPoint(int x, int y, int c) {
//       super(x, y);
//       color = c; 
//    }
//    public void print() {
//      System.out.print("<font color='" + color + "'>");     // F̎w 
//      System.out.print("(" + x + ", " + y + ")");
//                // super.print();ł
//      System.out.print("</font>");                     // F߂
//    }
// }

// version 2
class ColorPoint extends Point {
  public String[] cs = {"black", "red", "green", "yellow",
			"blue", "magenta", "cyan", "white", ""}; 
  private int color;     // 0- 1- 2- 3- 4- 5- 6- 7-
  public void print() {
    System.out.print("<font color='"+getColor()+"'>");     // F̎w 
    // System.out.print("(" + x + ", " + y + ")");
    super.print();//ł
    System.out.print("</font>");                     // F߂
  }
  public void setColor(String c) {
    int i; 
    for (i=0; !cs[i].equals(""); i++) {
      if (c.equals(cs[i])) {
	color = i; return; 
      }
    }
    // ΉFȂ牽ȂB
  }
  public ColorPoint(int x, int y, String c) {
    super(x, y);
    setColor(c); 
  }
  public String getColor() {
    return cs[color];
  }
}
